//
// Created by ascadian on 12/2/17.
//

#pragma once
#include <boost/asio.hpp>
#include <thread>
#include <opencv2/opencv.hpp>
#include "src/ReactDomain.h"

namespace dyncam {

class Connection;
class StreamCollection;

class ClientBase {
public:

    virtual ~ClientBase();

    void start(std::string address, std::string port = "4242");
    void start(boost::asio::ip::basic_endpoint<boost::asio::ip::tcp> endpoint);
    void stop();

protected:
    ClientBase();

    void sendConnInfo();
    void readConnInfo();

    virtual void on_connected() {}

    std::thread m_thread;

    boost::asio::io_service m_io_service;
    boost::asio::ip::tcp::resolver m_resolver;
    boost::asio::ip::basic_endpoint<boost::asio::ip::tcp> m_endpoint;

    std::unique_ptr<Connection> m_connection;

};

} // namespace dyncam {