//
// Created by ascadian on 4/4/19.
//

#pragma once
#include <src/Core/Stream.h>
#include <src/Compression/BaseCompression.h>

namespace dyncam {

class ImageStream;

class CompressedStream : public Stream {
public:
    CompressedStream();

    explicit CompressedStream(std::shared_ptr<ImageStream> stream,
                              std::shared_ptr<BaseCompression> compression);

    template<class Archive>
    void serialize(Archive & ar)
    {
        ar (m_innerStream, m_compression);
    }

    std::shared_ptr<ImageStream> m_innerStream;
    std::shared_ptr<BaseCompression> m_compression;

    std::string ToString() override;
};

} // namespace dyncam

CEREAL_REGISTER_TYPE(dyncam::CompressedStream)
CEREAL_REGISTER_POLYMORPHIC_RELATION(dyncam::Stream, dyncam::CompressedStream)
