//
// Created by ascadian on 12/16/17.
//

#pragma once
#include "../ReactDomain.h"
#include "BaseCompression.h"
#include <opencv2/opencv.hpp>

namespace dyncam {

class Lz4QuantCompression : public BaseCompression {

protected:
    cv::Size outSize = cv::Size(-1, -1);
    int outType = -1;
public:
    Lz4QuantCompression() = default;
    Lz4QuantCompression(const cv::Size m_outSize, const int m_outType);

    template<class Archive>
    void save(Archive& ar) const {
        ar (outSize, outType);
    }

    template<class Archive>
    void load(Archive& ar) {
        ar (outSize, outType);
    }

    EventsT<cv::Mat> compress(const EventsT<cv::Mat> &inStream) override;
    EventsT<cv::Mat> deCompress(const EventsT<cv::Mat> &inStream) override;

    std::string ToString() override;
};

} // namespace dyncam

CEREAL_REGISTER_TYPE(dyncam::Lz4QuantCompression)
CEREAL_REGISTER_POLYMORPHIC_RELATION(dyncam::BaseCompression, dyncam::Lz4QuantCompression)
CEREAL_SPECIALIZE_FOR_ALL_ARCHIVES(dyncam::Lz4QuantCompression, cereal::specialization::member_load_save)