
#pragma once

#include <opencv2/opencv.hpp>

#include "src/ReactDomain.h"
#include "Stream.h"

namespace dyncam {

class ImageStream : public Stream {
public:
    ImageStream();
    ImageStream(StreamTypes type, int parent_id, cv::Size resolution, int cvPixelType);

    std::string ToString() override;

    D::EventsT<cv::Mat> events;
    D::VarSignalT<cv::Size> m_resolution;
    D::VarSignalT<int> m_cvPixelType;

    template<class Archive>
    void save(Archive& ar) const {
        ar (cereal::virtual_base_class<Stream>(this),
            m_resolution.Value(),
            m_cvPixelType.Value());
    }

    template<class Archive>
    void load(Archive& ar) {
        ar (cereal::virtual_base_class<Stream>(this));
        cv::Size res;
        int pixelType;
        ar(res, pixelType);
        m_resolution.Set(res);
        m_cvPixelType.Set(pixelType);

        //events = MakeEventSource<D, cv::Mat>();
    }
};

} // namespace dyncam

CEREAL_REGISTER_TYPE(dyncam::ImageStream)
CEREAL_REGISTER_POLYMORPHIC_RELATION(dyncam::Stream, dyncam::ImageStream)
CEREAL_SPECIALIZE_FOR_ALL_ARCHIVES(dyncam::ImageStream, cereal::specialization::member_load_save)