//
// Created by ascadian on 6/22/18.
//
#pragma once

#include <opencv2/opencv.hpp>
#include <src/Core/Intrinsics.h>

#include "src/ReactDomain.h"
#include "Stream.h"

namespace dyncam {

class IntrinsicsStream : public Stream {
public:
    IntrinsicsStream();
    explicit IntrinsicsStream(int parent_id);

    std::string ToString() override;

    D::VarSignalT<CamIntrinsics> Intrinsics = MakeVar<D>(CamIntrinsics());

    template<class Archive>
    void save(Archive& ar) const {
        ar (cereal::virtual_base_class<Stream>(this),
            Intrinsics.Value());
    }

    template<class Archive>
    void load(Archive& ar) {
        ar (cereal::virtual_base_class<Stream>(this));
        CamIntrinsics intr;
        ar(intr);
        Intrinsics.Set(intr);
    }
};

} // namespace dyncam

CEREAL_REGISTER_TYPE(dyncam::IntrinsicsStream)
CEREAL_REGISTER_POLYMORPHIC_RELATION(dyncam::Stream, dyncam::IntrinsicsStream)
CEREAL_SPECIALIZE_FOR_ALL_ARCHIVES(dyncam::IntrinsicsStream, cereal::specialization::member_load_save)