//
// Created by ascadian on 04/04/19.
//

#include <memory>

#include "gtest/gtest.h"
#include "src/ReactDomain.h"
#include "src/Cams/TestCam/TestCam.h"
#include "src/Compression/ColorCompression.h"
#include "src/Compression/QuantizedCompression.h"
//#include <src/Compression/Lz4Compression.h>
#include "TestUtils.h"
#include <src/Cams/NetCam/CompressedStream.h>
#include "src/Cams/NetCam/StreamServer.h"
#include <src/Cams/NetCam/StreamClient.h>

namespace {
using std::string;

class CompressionNetTest : public ::testing::Test {
protected:

    CompressionNetTest() {

    }

    virtual ~CompressionNetTest() {
        // You can do clean-up work that doesn't throw exceptions here.
    }

    std::shared_ptr<TestCam> cam = std::make_shared<TestCam>();
};

TEST_F(CompressionNetTest, CompressedEqDecompressed) {
    auto depth = cam->Streams.GetStreamFirst<ImageStream>(StreamTypes::COLOR);

    auto server = std::make_shared<StreamServer>();
    server->AddStream(depth);
    std::this_thread::sleep_for(std::chrono::milliseconds(10));

    // client automatically requests stream list from server
    StreamClient client;
    client.start("127.0.0.1");
    std::this_thread::sleep_for(std::chrono::milliseconds(10));


    auto depth_client = client.m_streams->GetStreamFirst<ImageStream>(StreamTypes::COLOR);
    auto cs_client = std::make_shared<CompressedStream>(depth_client,
        std::make_unique<ColorCompression>(COMPRESSIONS::PNG));

    client.requestStream(cs_client);

    std::this_thread::sleep_for(std::chrono::milliseconds(10));

    std::cout << "Starting cam" << std::endl;
    cam->Open();

    std::this_thread::sleep_for(std::chrono::milliseconds(50));

    TestUtils::compareFirstImageTwoStreams(depth->events, depth_client->events);
}

} // namespace
