//
// Created by ascadian on 12/7/17.
//

#include "Camera.h"
#include <QMatrix4x4>
#include <cmath>


Camera::Camera() {
}

void Camera::getCamMat (QMatrix4x4 &matrix) {
    matrix.lookAt(m_pos, m_pos + m_viewDir, m_up);
}


void Camera::turn (float radX, float radY)
{
    auto strafeDir = QVector3D::crossProduct(m_up, m_viewDir);
    QMatrix4x4 rotator;
    rotator.rotate(radX, m_up);
    rotator.rotate(-radY, strafeDir);
    m_viewDir = rotator * m_viewDir;
}

void Camera::move_forward (float d)
{
    m_pos += m_viewDir * d;
}

void Camera::move_to(QVector3D pos) {
    m_pos = pos;
}

void Camera::strafe(float d) {
    auto strafeDir = QVector3D::crossProduct(m_viewDir, m_up);
    m_pos += strafeDir * d;
}

void Camera::up(float d) {
    m_pos += m_up * d;
}
