//
// Created by ascadian on 12/6/17.
//

#pragma once

#include <vector>
#include <sstream>
#include <boost/circular_buffer.hpp>
#include <QElapsedTimer>


class FrameTime {
    // number of frame times to remember
    boost::circular_buffer<qint64 > cb{50, 0};
    QElapsedTimer timer;
    qint64 msecSinceLastPrint = 0;
    qint64 printInterval = 1000 * 1000 * 1000; // nanoseconds

    qint64 updateCalls = 0;

    void updateStats();

public:
    void start();
    void update();

    qint64 minFrametime = 0;
    qint64 maxFrametime = 0;
    qint64 avgFrametime = 0;

    void printStats();
    std::ostringstream formatStats();

};


