
#pragma once

#include <memory>
#include <iostream>
#include "dynunreal_export.h"

//...standard class body

class DYNUNREAL_EXPORT UnrealInterface {
private:
    class impl;
    std::unique_ptr<impl> pimpl;

public:
    UnrealInterface();
    ~UnrealInterface();

    // redirect std::cout to another stream
    // usefull for unreal debugging
    static void setCout(std::streambuf* sb);

    uint8_t* getPCColor() const;
    float* getPCPoints() const;

    bool getPointsDirty() const;

	void initConnection(const char * IPIn = "127.0.0.1", const char * portIn = "4242");
	bool requestStreams();
	void killConnections();
};
